Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 24)
@@ -28,5 +28,4 @@
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.WillBeCalled;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
@@ -51,26 +50,28 @@
  * <h1>parameter</h1> AMOP parties can receive a parameter: minVotes containing
  * a Double. If set, the AMOP protocol checks that all {@link Votes} from that
- * party have {@link Vote#getMinPower()} > minVotes.
- * <h1>Protocol steps</h1> The protocol tries to start all parties. If not all
- * parties start, the parties are freed up and another attempt is done to start
- * all parties some time later.
+ * party have {@link Vote#getMinPower()} &gt; minVotes.
+ * <h1>Protocol steps</h1>
+ * <ol>
+ * <li>The protocol tries to start all parties. If not all parties start, the
+ * parties are freed up and another attempt is done to start all parties some
+ * time later.
  * <li>the variable remainingparties = {all parties}
  * <li>The session deadline clock now starts ticking.
  * <li>All parties are sent their settings.
- * <li>Loop until {@link Deadline} is reached or |remainingparties|<2:
+ * <li>Loop until {@link Deadline} is reached or |remainingparties|&lt;2:
  * <ol>
  * <li>protocol sends {@link YourTurn} to all remainingparties. Each party now
  * must submit an {@link Offer} within {@link #PHASE_TIME} seconds. If a party
  * fails to submit it is send Finished and removed from from remainingparties.
- * <li>protocol sends a {@link Voting} containing a List<Bid> containing all
- * received {@link Bid}s. Each party must place his {@link Votes} within
- * {@link #PHASE_TIME} seconds. If a party does not submit, it is send a
+ * <li>protocol sends a {@link Voting} containing a List of {@link Bid}
+ * containing all received {@link Bid}s. Each party must place his {@link Votes}
+ * within {@link #PHASE_TIME} seconds. If a party does not submit, it is send a
  * {@link Finished} and removed from remainingparties. Previous votes for the
  * same bid do not count. But see {@link Agreements}.
- * <li>The protocol determines a maximum sized subset of size N>=2 of the votes
- * for bid B for which the vote conditions hold. If there is such a subset, the
- * parties that placed these votes reached an agreement. They are added to the
- * agreement set, sent the {@link Finished} info and terminated. They are
- * removed from the remainingparties.
+ * <li>The protocol determines a maximum sized subset of size N&ge;2 of the
+ * votes for bid B for which the vote conditions hold. If there is such a
+ * subset, the parties that placed these votes reached an agreement. They are
+ * added to the agreement set, sent the {@link Finished} info and terminated.
+ * They are removed from the remainingparties.
  * </ol>
  * <li>Any remaining parties are sent a {@link Finished} object without
@@ -109,5 +110,6 @@
 	/**
 	 * 
-	 * @param state normally the initial state coming from SAOPSettings
+	 * @param state  normally the initial state coming from SAOPSettings
+	 * @param logger the {@link Reporter} to use
 	 */
 	public AMOP(AMOPState state, Reporter logger) {
@@ -218,6 +220,6 @@
 	 * overridable factory method, used for testing.
 	 * 
-	 * @param r
-	 * @param delayMs
+	 * @param r       the {@link Runnable} that will be called
+	 * @param delayMs the time after which r will be called
 	 * @return new WillBeCalled(r,delayms)
 	 */
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPSettings.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPSettings.java	(revision 24)
@@ -30,6 +30,5 @@
 	 *                     protocol. But SAOP can be initialized with less, for
 	 *                     use in TournamentSettings.
-	 * @param deadline
-	 * @param minimumVotes the minimum number of votes allowed for a bid.
+	 * @param deadline     the {@link Deadline} of the negotiation
 	 */
 	@JsonCreator
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 24)
@@ -197,11 +197,8 @@
 
 	/**
-	 * @param actor         the actor that did this action. Can be used to check
-	 *                      if action is valid. NOTICE caller has to make sure
-	 *                      the current state is not final. MUST NOT be null.
-	 * @param action        the action that was proposed by actor. MUST NOT be
-	 *                      null.
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
+	 * @param actor  the actor that did this action. Can be used to check if
+	 *               action is valid. NOTICE caller has to make sure the current
+	 *               state is not final. MUST NOT be null.
+	 * @param action the action that was proposed by actor. MUST NOT be null.
 	 * @return new SessionState with the action added as last action.
 	 * @throws ProtocolException if actor is violating the protocol
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/WillBeCalled.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/WillBeCalled.java	(revision 24)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/WillBeCalled.java	(revision 24)
@@ -0,0 +1,46 @@
+package geniusweb.protocol.session.amop;
+
+import java.util.concurrent.ScheduledThreadPoolExecutor;
+import java.util.concurrent.TimeUnit;
+import java.util.concurrent.atomic.AtomicBoolean;
+
+/**
+ * Object containing function that will be called exactly once, on demand or at
+ * given deadline.
+ *
+ */
+public class WillBeCalled {
+	private static volatile ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(
+			2);
+	private final Runnable runnable;
+	private volatile AtomicBoolean done = new AtomicBoolean(false);
+
+	/**
+	 * @param r       the runnable that will be run once, either when the user
+	 *                calls {@link #complete()} or after delayMs, whichever
+	 *                comes first.
+	 * @param delayMs the delay after this will be called anywa (the 'deadline'
+	 *                in milliseconds. If null, no deadline call will be made
+	 *                and the user must call {@link #complete()} himself.
+	 */
+	public WillBeCalled(Runnable r, Long delayMs) {
+		this.runnable = r;
+		if (delayMs != null) {
+			executor.schedule(() -> complete(), delayMs, TimeUnit.MILLISECONDS);
+		}
+	}
+
+	/**
+	 * Tells the runnable to be executed. Only the first time the function is
+	 * run, subsequent calls do nothing. Failures in runnable are NOT caught
+	 * here, as they are probably bugs
+	 * 
+	 * We must avoid synchronized here because users may use synchronized blocks
+	 * already.
+	 */
+	public void complete() {
+		if (!done.compareAndSet(false, true))
+			return;
+		runnable.run();
+	}
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 24)
@@ -2,4 +2,5 @@
 
 import java.io.IOException;
+import java.util.Collections;
 import java.util.List;
 import java.util.Timer;
@@ -55,26 +56,25 @@
  * parties are freed up and another attempt is done to start all parties some
  * time later.
- * <li>the variable remainingparties = {all parties}
  * <li>The session deadline clock now starts ticking.
  * <li>remainingparties are sent their settings.
- * <li>Loop until {@link Deadline} is reached or |remainingparties|<2:
+ * <li>Loop until {@link Deadline} is reached or |remainingparties| &le; 2:
  * <ol>
  * <li>protocol sends {@link YourTurn} to all remainingparties. Each party now
  * must submit an {@link Offer} within {@link Phase#PHASE_MAXTIME} seconds. If a
  * party fails to submit it is removed from from remainingparties.
- * <li>protocol sends a {@link Voting} containing a List<Bid> containing all
- * received {@link Bid}s. Each party must place his {@link Votes} within
- * {@link #PHASE_TIME} seconds. If a party does not submit, it is terminated and
- * removed from remainingparties. Previous votes for the same bid do not count.
- * But see {@link Agreements}. A party that misbehaves after submitting its vote
- * is removed but it Votes remain standing.
+ * <li>protocol sends a {@link Voting} containing a List of Bid containing all
+ * received {@link Bid}s. Each party must place his {@link Votes} within the
+ * provided deadline. If a party does not submit, it is terminated and removed
+ * from remainingparties. Previous votes for the same bid do not count. But see
+ * {@link Agreements}. A party that misbehaves after submitting its vote is
+ * removed but it Votes remain standing.
  * <li>protocol sends to all remainingparties a OptIn containing all received
- * votes. Each party now must submit again a {@link Votes} object within
- * {@link #PHASE_TIME} seconds. This new Votes must equal or extend the previous
- * Votes of the party.
- * <li>The protocol use the {@link MOPACState#getEvaluator()} to determine the
- * ... . If there is such a subset, the parties that placed these votes reached
- * an agreement. They are added to the agreement set, sent the {@link Finished}
- * info and terminated. They are removed from the remainingparties.
+ * votes. Each party now must submit again a {@link Votes} object within the
+ * deadline. This new Votes must equal or extend the previous Votes of the
+ * party.
+ * <li>The protocol uses the {@link Phase#getEvaluator()} to determine the
+ * agreements from the votes. If there are agreements, the parties that placed
+ * these votes reached an agreement. They are moved to the agreement set and
+ * removed from the remainingparties.
  * </ol>
  * <li>Any remaining parties are sent a {@link Finished} object without
@@ -114,4 +114,10 @@
 	private final Reporter log;
 	private MOPACState state = null; // mutable!
+	/**
+	 * the existing party connections. we assume ownership of this so it should
+	 * not be modified although connections may of course break. mutable!
+	 */
+	private ProtocolToPartyConnections connections = new ProtocolToPartyConnections(
+			Collections.emptyList());
 
 	/**
@@ -124,5 +130,6 @@
 	/**
 	 * 
-	 * @param state normally the initial state coming from SAOPSettings
+	 * @param state  normally the initial state coming from SAOPSettings
+	 * @param logger the {@link Reporter} to use
 	 */
 	public MOPAC(MOPACState state, Reporter logger) {
@@ -145,15 +152,16 @@
 			ProtocolToPartyConnFactory connectionfactory) {
 		try {
-			// System.out.println("starting MOPAC");
-			// we're in Phase.INIT still
 			connect(connectionfactory);
-			setupParties();
-			long now = System.currentTimeMillis();
-			state = state.initPhase(now);
-			startPhase(now);
 		} catch (Throwable e) {
-			e.printStackTrace();
-			handleError("Failed to start MOPAC session", new PartyId("BUG"), e);
-		}
+			/** We can't {@link #handleError} yet. FIXME */
+			throw new RuntimeException("Failed to connect", e);
+		}
+		long now = System.currentTimeMillis();
+		state = state.initPhase(
+				ProgressFactory.create(state.getSettings().getDeadline(), now),
+				now);
+		setupParties(now);
+		startPhase(now);
+
 	}
 
@@ -212,9 +220,9 @@
 				.map(parti -> (parti.getParty().getPartyRef()))
 				.collect(Collectors.toList());
-		List<ProtocolToPartyConn> connections = null;
 		log.log(Level.INFO, "MOPAC connect " + parties);
-		while (connections == null) {
+		List<ProtocolToPartyConn> newconnections = null;
+		while (newconnections == null) {
 			try {
-				connections = connectionfactory.connect(parties);
+				newconnections = connectionfactory.connect(parties);
 			} catch (NoResourcesNowException e) {
 				long waitms = e.getLater().getTime()
@@ -228,5 +236,7 @@
 		}
 		for (int i = 0; i < participants.size(); i++) {
-			state = state.with(connections.get(i), participants.get(i));
+			ProtocolToPartyConn conn = newconnections.get(i);
+			connections = connections.with(conn);
+			state = state.with(conn.getParty(), participants.get(i));
 		}
 	}
@@ -239,15 +249,11 @@
 	 * part of the interface.
 	 * 
-	 * @throws ProtocolException if a party does not follow the protocol
-	 */
-	protected synchronized void setupParties() throws ProtocolException {
-		for (ProtocolToPartyConn conn : state.getConnections()) {
-			conn.addListener(action -> actionRequest(conn, action,
-					System.currentTimeMillis()));
-		}
-		Long now = System.currentTimeMillis();
-		state = state.with(
-				ProgressFactory.create(state.getSettings().getDeadline(), now));
-		for (ProtocolToPartyConn connection : state.getConnections()) {
+	 * @param now the current time.
+	 */
+	protected synchronized void setupParties(long now) {
+		for (ProtocolToPartyConn conn : connections) {
+			conn.addListener(action -> actionRequest(conn, action, now));
+		}
+		for (ProtocolToPartyConn connection : connections) {
 			try {
 				sendSettings(connection);
@@ -257,5 +263,4 @@
 			}
 		}
-
 	}
 
@@ -357,49 +362,11 @@
 				.getNegotiatingParties()) {
 			try {
-				state.getConnections().get(party).send(info);
+				connections.get(party).send(info);
 			} catch (IOException e) {
-				handleError("Party seems to have disconnected", party, e);
-			}
-		}
-	}
-
-	/**
-	 * Update state to include the given error and closes the party.
-	 * 
-	 * @param message The message to attach to the error
-	 * @param party   the party where the error occured
-	 * @param e       the exception that occured.
-	 */
-	private void handleError(final String message, final PartyId partyid,
-			final Throwable e) {
-		if (e instanceof ProtocolException) {
-			state = state.with((ProtocolException) e);
-		} else {
-			state = state.with(new ProtocolException(message, partyid, e));
-		}
-		log.log(Level.WARNING,
-				"MOPAC intercepted error from party " + partyid + ":" + message,
-				e);
-	}
-
-//	/**
-//	 * Sets the new state. If the new state is final, the finish-up procedure is
-//	 * executed. All state changes go through here to ensure we check isFinal
-//	 * before any state change.
-//	 * 
-//	 * @param newstate the new state.
-//	 */
-//	private synchronized void setState(MOPACState newstate) {
-//		long now = System.currentTimeMillis();
-//		if (state.isFinal(now)) {
-//			endNegotiation();
-//			return;
-//		}
-//
-//		this.state = newstate;
-//		if (newstate.isFinal(now)) {
-//			endNegotiation();
-//		}
-//	}
+				state = state.with(new ProtocolException(
+						"Party seems to have disconnected", party, e));
+			}
+		}
+	}
 
 	/**
@@ -413,5 +380,5 @@
 		finished = true;
 		Finished info = new Finished(state.getAgreements());
-		for (ProtocolToPartyConn conn : state.getConnections()) {
+		for (ProtocolToPartyConn conn : connections) {
 			try {
 				conn.send(info);
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACSettings.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPACSettings.java	(revision 24)
@@ -19,5 +19,5 @@
 /**
  * Settings for MOPAC negotiation. in MOPAC, each party may get a "power"
- * parameter containing an natural number >=1.
+ * parameter containing an natural number &le;1.
  */
 public class MOPACSettings implements SessionSettings {
@@ -30,11 +30,9 @@
 	 * @param participants the list of {@link PartyWithProfile} in clockwise
 	 *                     order. There must be at least 2 to run the MOPAC
-	 *                     protocol. But SAOP can be initialized with less, for
-	 *                     use in TournamentSettings.
-	 * 
-	 *                     All provided participants must
-	 * 
-	 * @param deadline
-	 * @param minimumVotes the minimum number of votes allowed for a bid.
+	 *                     protocol. This is not tested in the constructor
+	 *                     because this can be initialized with less, for use in
+	 *                     TournamentSettings.
+	 * @param deadline     the {@link Deadline} for the negotiation
+	 * @param votingeval   the {@link VotingEvaluator} to use.
 	 */
 	@JsonCreator
@@ -90,5 +88,5 @@
 
 	@Override
-	public SessionSettings with(TeamOfPartiesAndProfiles party) {
+	public MOPACSettings with(TeamOfPartiesAndProfiles party) {
 		if (!(party instanceof OnePartyTeam))
 			throw new IllegalArgumentException(
